Adjust menu.lst + isolinux.cfg on the fly for new directoy layout
[grml-live.git] / grml-live
index 4fbed19..fc18116 100755 (executable)
--- a/grml-live
+++ b/grml-live
@@ -4,7 +4,7 @@
 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2 or any later version.
-# Latest change: Mit Okt 10 09:38:42 CEST 2007 [mika]
+# Latest change: Fri Feb 15 14:28:37 CET 2008 [mika]
 ################################################################################
 
 # read configuration files, set some misc variables {{{
@@ -15,6 +15,10 @@ export LC_ALL=C
 # exit on any error:
 set -e
 
+GRML_LIVE_VERSION='0.4'
+CMDLINE="$0 $@"
+ISO_DATE="$(date +%Y-%m-%d)"
+
 # we need root permissions for the build-process:
 if [ "$(id -u 2>/dev/null)" != 0 ] ; then
    echo "Error: please run this script with uid 0 (root)." >&2
@@ -22,14 +26,24 @@ if [ "$(id -u 2>/dev/null)" != 0 ] ; then
 fi
 
 if [ -r /var/run/fai/FAI_INSTALLATION_IN_PROGRESS ] ; then
-   echo "/usr/sbin/fai already running or was aborted before."&>2
+   echo "/usr/sbin/fai already running or was aborted before.">&2
    echo "You may remove /var/run/fai/FAI_INSTALLATION_IN_PROGRESS and try again.">&2
    exit 1
 fi
 
+# see #449236
+if [ -r /var/run/fai/fai_softupdate_is_running ] ; then
+   echo "/usr/sbin/fai softupdate already running or was aborted before.">&2
+   echo "You may remove /var/run/fai/fai_softupdate_is_running and try again.">&2
+   exit 1
+fi
+
 # make sure they are not set by default
 VERBOSE=''
 FORCE=''
+UPDATE=''
+BUILD_ONLY=''
+HOSTNAME=''
 
 if [ -r /etc/grml/lsb-functions ] ; then
    . /etc/grml/lsb-functions
@@ -50,10 +64,14 @@ PN=$(basename $0)
 # clean exit {{{
 bailout() {
   [ -n "$MIRROR_DIRECTORY" ] && umount "${CHROOT_OUTPUT}/${MIRROR_DIRECTORY}"
+  rm -f /var/run/fai/fai_softupdate_is_running \
+        /var/run/fai/FAI_INSTALLATION_IN_PROGRESS
   [ -n "$1" ] && EXIT="$1" || EXIT="1"
   [ -n "$2" ] && eerror "$2">&2
+  log "------------------------------------------------------------------------------"
   exit "$EXIT"
 }
+# trap bailout 1 2 3 6 9 14 15
 trap bailout 1 2 3 15
 # }}}
 
@@ -69,8 +87,16 @@ trap bailout 1 2 3 15
 [ -n "$RELEASENAME" ] || RELEASENAME="grml-live rocks"
 [ -n "$GRML_NAME" ] || GRML_NAME='grml'
 
-[ -n "$LOGDIR" ] || LOGDIR="/var/log/"
-LOGFILE="$LOGDIR/grml-live.log"
+# logfile:
+if [ -z "$LOGFILE" ] ; then
+   LOGFILE=/var/log/grml-live.log
+fi
+touch $LOGFILE
+chown root:adm $LOGFILE
+chmod 664 $LOGFILE
+
+NFSROOT_CONF=/etc/grml/fai/make-fai-nfsroot.conf
+
 # }}}
 
 # some important functions {{{
@@ -128,9 +154,10 @@ usage()
   echo "
 $PN - build process script for generating a (grml based) Linux Live-ISO
 
-Usage: $PN [-c <classe[s]>] [-g <grml_name>] [-i <iso_name> ] \\
-                 [-o <output_directory>] [-s <suite>] [-t <template_directory>] \\
-                 [-s <suite>] [-v <version_number>] [-FVh]
+Usage: $PN [-a <architecture>] [-c <classe[s]>] [-g <grml_name>] \\
+                 [-i <iso_name> ] [-o <output_directory>] [-s <suite>] \\
+                 [-t <template_directory>] [-s <suite>] \\
+                 [-v <version_number>] [-bFVhu]
 
 Usage examples:
 
@@ -138,8 +165,8 @@ Usage examples:
     $PN -c GRMLBASE,GRML_SMALL,I386 -o /grml/
     $PN -c GRMLBASE,GRML_MEDIUM,I386 -o /dev/shm/grml
     $PN -c GRMLBASE,GRML_SMALL,I386 -g grml-small -v 1.0
-    $PN -c GRMLBASE,GRML_FULL,I386 -i grml_0.0-1.iso
-    $PN -c GRMLBASE,GRML_FULL,I386 -s sid -V
+    $PN -c GRMLBASE,GRML_FULL,I386 -i grml_0.0-1.iso -v 0.0-1
+    $PN -c GRMLBASE,GRML_FULL,I386 -s sid -V -r 'grml-live rocks'
 
 More details: man grml-live
               /usr/share/doc/grml-live/grml-live.html
@@ -150,31 +177,44 @@ http://grml.org/bugs/
 }
 # }}}
 
-# command line parsing {{{
+# read local (non-packaged) configuration {{{
+LOCAL_CONFIG=/etc/grml/grml-live.local
+if [ -r "$LOCAL_CONFIG" ] ; then
+   log "Sourcing $LOCAL_CONFIG"
+   . $LOCAL_CONFIG
+else
+   log "No $LOCAL_CONFIG found, not sourcing it"
+   LOCAL_CONFIG=''
+fi
+# }}}
 
-while getopts "c:g:i:o:r:s:t:v:FhV" opt; do
+# command line parsing {{{
+while getopts "a:C:c:g:i:o:r:s:t:v:bFhuVz" opt; do
   case "$opt" in
+    a) ARCH="$OPTARG" ;;
+    b) BUILD_ONLY=1 ;;
     c) CLASSES="$OPTARG" ;;
+    C) CONFIG="$OPTARG" ;;
     g) GRML_NAME="$OPTARG" ;;
     i) ISO_NAME="$OPTARG" ;;
-    r) RELEASENAME="$OPTARG" ;;
-    s) SUITE="$OPTARG" ;;
-    t) TEMPLATE_DIRECTORY="$OPTARG";;
     o) OUTPUT="$OPTARG"
        CHROOT_OUTPUT="$OUTPUT/grml_chroot"
        BUILD_OUTPUT="$OUTPUT/grml_cd"
        ISO_OUTPUT="$OUTPUT/grml_isos"
        ;;
+    r) RELEASENAME="$OPTARG" ;;
+    s) SUITE="$OPTARG" ;;
+    t) TEMPLATE_DIRECTORY="$OPTARG";;
     v) VERSION="$OPTARG" ;;
     F) FORCE=1 ;;
     h) usage ; bailout 0 ;;
+    u) UPDATE=1 ;;
     V) VERBOSE="-v" ;;
+    z) SQUASHFS_ZLIB="-nolzma" ;;
     ?) echo "invalid option -$OPTARG" >&2; bailout 1 ;;
   esac
 done
 shift $(($OPTIND - 1))  # set ARGV to the first not parsed commandline parameter
-
-echo "Executing: $(basename $0) $*" >> $LOGFILE
 # }}}
 
 # some misc checks before executing FAI {{{
@@ -184,12 +224,33 @@ specify it on the command line using the -c option."
 specify it on the command line using the -o option."
 # }}}
 
+# clean/zero grml-live logfile {{{
+if [ -n "$ZERO_LOGFILE" ] ; then
+   echo -n > $LOGFILE
+fi
+# }}}
+
+# clean/zero/remove old FAI directory {{{
+if [ -n "$ZERO_FAI_LOGFILE" ] ; then
+   if [ -d /var/log/fai/"$HOSTNAME" ] ; then
+      rm -rf /var/log/fai/"$HOSTNAME"/"$(readlink /var/log/fai/"$HOSTNAME"/last)"
+      rm -rf /var/log/fai/"$HOSTNAME"/"$(readlink /var/log/fai/"$HOSTNAME"/last-dirinstall)"
+      rm -rf /var/log/fai/"$HOSTNAME"/"$(readlink /var/log/fai/"$HOSTNAME"/last-softupdate)"
+      rm -f /var/log/fai/"$HOSTNAME"/last \
+            /var/log/fai/"$HOSTNAME"/last-dirinstall \
+            /var/log/fai/"$HOSTNAME"/last-softupdate
+   fi
+fi
+# }}}
+
 # ask user whether the setup is ok {{{
 if [ -z "$FORCE" ] ; then
    echo
-   echo "${PN}: check your configuration (or use -F to force execution without prompting):"
+   echo "${PN} [${GRML_LIVE_VERSION}]: check your configuration (or use -F to force execution):"
    echo
    echo "  FAI classes:       $CLASSES"
+   [ -r "$LOCAL_CONFIG" ]  && echo "  local config:      /etc/grml/grml-live.local"
+   [ -n "$CONFIG" ]        && echo "  configuration:     $CONFIG"
    echo "  main directory:    $OUTPUT"
    [ -n "$CHROOT_OUTPUT" ] && echo "  chroot target:     $CHROOT_OUTPUT"
    [ -n "$BUILD_OUTPUT" ]  && echo "  build target:      $BUILD_OUTPUT"
@@ -198,10 +259,15 @@ if [ -z "$FORCE" ] ; then
    [ -n "$RELEASENAME" ]   && echo "  release name:      $RELEASENAME"
    [ -n "$VERSION" ]       && echo "  grml version:      $VERSION"
    [ -n "$SUITE" ]         && echo "  Debian suite:      $SUITE"
+   [ -n "$ARCH" ]          && echo "  Architecture:      $ARCH"
    [ -n "$BOOT_METHOD" ]   && echo "  Boot method:       $BOOT_METHOD"
    [ -n "$TEMPLATE_DIRECTORY" ] && echo "  Template files:    $TEMPLATE_DIRECTORY"
    [ -n "$FAI_ARGS" ]      && echo "  additional arguments for FAI: $FAI_ARGS"
+   [ -n "$LOGFILE" ]       && echo "  Logging to file:   $LOGFILE"
    [ -n "$VERBOSE" ]       && echo "  Using VERBOSE mode."
+   [ -n "$SQUASHFS_ZLIB" ] && echo "  Using ZLIB (instead of LZMA) compression."
+   [ -n "$UPDATE" ]        && echo "  Executing UPDATE instead of fresh installation."
+   [ -n "$BUILD_ONLY" ]    && echo "  Executing BUILD_ONLY instead of fresh installation or UPDATE."
    echo
    echo -n "Is this ok for you? [y/N] "
    read a
@@ -209,11 +275,26 @@ if [ -z "$FORCE" ] ; then
       bailout 1 "Exiting as requested."
    fi
    echo
+fi
 
-   start_seconds=$(cut -d . -f 1 /proc/uptime)
-   log "------------------------------------------------------------------------------"
-   log "Starting grml-live run [$(date)]"
+if [ -n "$CONFIG" ] ; then
+   if ! [ -f "$CONFIG" ] ; then
+      log "Sorry, $CONFIG could not be read. Exiting. [$(date)]"
+      eerror "Sorry, $CONFIG could not be read. Exiting."
+      bailout 1
+   else
+      log "Sourcing $CONFIG"
+      . $CONFIG
+   fi
 fi
+
+start_seconds=$(cut -d . -f 1 /proc/uptime)
+log "------------------------------------------------------------------------------"
+log "Starting grml-live [${GRML_LIVE_VERSION}] run on $(date)"
+log "Executed grml-live command line:"
+log "$CMDLINE"
+
+einfo "Logging actions to logfile $LOGFILE"
 # }}}
 
 # on-the-fly configuration {{{
@@ -232,56 +313,114 @@ elif [ -n "$GRML_LIVE_SOURCES" ] ; then
 fi
 
 if [ -n "$FAI_DEBOOTSTRAP" ] ; then
-   sed -i "s#^FAI_DEBOOTSTRAP=.*#FAI_DEBOOTSTRAP=\"$FAI_DEBOOTSTRAP\"#" /etc/grml/fai/make-fai-nfsroot.conf
+   sed -i "s#^FAI_DEBOOTSTRAP=.*#FAI_DEBOOTSTRAP=\"$FAI_DEBOOTSTRAP\"#" $NFSROOT_CONF
 fi
 
 # does this suck? YES!
 if [ -n "$SUITE" ] ; then
-   sed -i "s/SUITE=.*/SUITE=\"$SUITE\"/" $LIVE_CONF
 
-   DIST="\|\ etch\ \|\ stable\ \|\ lenny\ \|\ testing\ \|\ sid\ \|\ unstable\ "
-   sed -i "s/\(deb .\+\)\([ \t]+\)$DIST\([ \t]+\)\(main \)/\1\2 $SUITE \3\4/" $LIVE_CONF
+   for file in "$LIVE_CONF" "$CONFIG" "$LOCAL_CONFIG" ; do
+       if [ -n "$file" ] ; then
+          sed -i "s/SUITE=.*/SUITE=\"$SUITE\"/" $LIVE_CONF
+          DIST="\|\ etch\ \|\ stable\ \|\ lenny\ \|\ testing\ \|\ sid\ \|\ unstable\ "
+          sed -i "s/\(deb .\+\)\([ \t]+\)$DIST\([ \t]+\)\(main \)/\1\2 $SUITE \3\4/" $file
+       fi
+   done
+
    sed -i "s/\(deb .\+\)\([ \t]+\)$DIST\([ \t]+\)\(main \)/\1\2 $SUITE \3\4/" /etc/grml/fai/apt/sources.list
+   # notice: activate grml-live pool only if we are building against unstable:
+   if grep -qe unstable -qe sid /etc/grml/fai/apt/sources.list ; then
+      grep -q 'grml-live.*main' /etc/grml/fai/apt/sources.list || \
+      grep grml-stable /etc/grml/fai/apt/sources.list | \
+           sed 's/grml-stable/grml-live/' >> /etc/grml/fai/apt/sources.list
+   else
+      grep -q 'grml-live.*main' /etc/grml/fai/apt/sources.list && \
+      sed -i 's/.*grml-live.*/# removed grml-live repository/' /etc/grml/fai/apt/sources.list
+   fi
+
+   for file in "$LIVE_CONF" "$CONFIG" "$LOCAL_CONFIG" ; do
+       if [ -n "$file" ] ; then
+          sed -i "s|FAI_DEBOOTSTRAP=\"[a-z]* |FAI_DEBOOTSTRAP=\"$SUITE |" "$file"
+       fi
+   done
+   sed -i "s|FAI_DEBOOTSTRAP=\"[a-z]* |FAI_DEBOOTSTRAP=\"$SUITE |" $NFSROOT_CONF
+fi
 
-   sed -i "s|FAI_DEBOOTSTRAP=\"[a-z]* |FAI_DEBOOTSTRAP=\"$SUITE |" $LIVE_CONF
-   sed -i "s|FAI_DEBOOTSTRAP=\"[a-z]* |FAI_DEBOOTSTRAP=\"$SUITE |" /etc/grml/fai/make-fai-nfsroot.conf
+# set $ARCH
+[ -n "$ARCH" ] || ARCH="$(dpkg --print-architecture)"
+if grep -q -- 'FAI_DEBOOTSTRAP_OPTS.*--arch' $NFSROOT_CONF ; then
+   sed -i "s/--arch [a-z0-9]* /--arch $ARCH /" $NFSROOT_CONF
+else
+   sed -i "s|FAI_DEBOOTSTRAP_OPTS=\"\(.*\)|FAI_DEBOOTSTRAP_OPTS=\"--arch $ARCH \1|" $NFSROOT_CONF
 fi
 # }}}
 
 # CHROOT_OUTPUT - execute FAI {{{
 [ -n "$CHROOT_OUTPUT" ] || CHROOT_OUTPUT="$OUTPUT/grml_chroot"
 
-if [ -d "$CHROOT_OUTPUT/bin" ] ; then
+if [ -n "$UPDATE" -o -n "$BUILD_ONLY" ] ; then
+   FAI_ACTION=softupdate
+else
+   FAI_ACTION=dirinstall
+fi
+
+if [ -n "$UPDATE" -o -n "$BUILD_ONLY" ] ; then
+   if ! [ -r "$CHROOT_OUTPUT/etc/grml_version" ] ; then
+      log "Error: does not look like you have a working chroot. Updating/building not possible."
+      eerror "Error: does not look like you have a working chroot. Updating/building not possible. (Drop -u/-b option?)"
+      eend 1
+      bailout 20
+   fi
+fi
+
+if [ -d "$CHROOT_OUTPUT/bin" -a -z "$UPDATE" -a -z "$BUILD_ONLY" ] ; then
    log "$CHROOT_OUTPUT exists already, skipping stage 'fai dirinstall'"
    ewarn "$CHROOT_OUTPUT exists already, skipping stage 'fai dirinstall'" ; eend 0
 else
    mkdir -p "$CHROOT_OUTPUT" || bailout 5 "Problem with creating $CHROOT_OUTPUT for FAI"
+
    if [ -n "${MIRROR_DIRECTORY}" ] ; then
       mkdir -p "${CHROOT_OUTPUT}/${MIRROR_DIRECTORY}"
       mount --bind "${MIRROR_DIRECTORY}" "${CHROOT_OUTPUT}/${MIRROR_DIRECTORY}"
    fi
-   fai $VERBOSE -C "$GRML_FAI_CONFIG" -c"$CLASSES" -u "$HOSTNAME" dirinstall "$CHROOT_OUTPUT" $FAI_ARGS | tee -a $LOGFILE
+
+   log "Executed FAI command line:"
+   log "BUILD_ONLY=$BUILD_ONLY fai $VERBOSE -C $GRML_FAI_CONFIG -c$CLASSES -u $HOSTNAME $FAI_ACTION $CHROOT_OUTPUT $FAI_ARGS"
+   BUILD_ONLY="$BUILD_ONLY" fai $VERBOSE -C "$GRML_FAI_CONFIG" -c"$CLASSES" -u "$HOSTNAME" $FAI_ACTION "$CHROOT_OUTPUT" $FAI_ARGS | tee -a $LOGFILE
+
+   log "Setting /etc/grml_version to $GRML_NAME $VERSION Release Codename $RELEASENAME [$ISO_DATE]"
+   echo "$GRML_NAME $VERSION Release Codename $RELEASENAME [$ISO_DATE]" > $CHROOT_OUTPUT/etc/grml_version
+   chmod 644 $CHROOT_OUTPUT/etc/grml_version
+
+   # Remove all FAI logs from chroot if class RELEASE is used:
+   if [ -f "$CHROOT_OUTPUT"/etc/grml_fai_release ] ; then
+      rm -rf "$CHROOT_OUTPUT"/var/log/fai/*
+   fi
+
    umount $CHROOT_OUTPUT/proc 2>/dev/null || /bin/true
    umount $CHROOT_OUTPUT/sys  2>/dev/null || /bin/true
    [ -n "$MIRROR_DIRECTORY" ] && umount "${CHROOT_OUTPUT}/${MIRROR_DIRECTORY}"
 
    # notice: 'fai dirinstall' does not seem to exit appropriate, so:
    ERROR=''
-   if [ -r "/var/log/fai/dirinstall/$HOSTNAME/software.log" ] ; then
+   CHECKLOG=/var/log/fai/$HOSTNAME/last
+   if [ -r "$CHECKLOG/software.log" ] ; then
       # 1 errors during executing of commands
-      grep 'dpkg: error processing' /var/log/fai/dirinstall/$HOSTNAME/software.log >> $LOGFILE && ERROR=1
-      grep 'E: Method http has died unexpectedly!' /var/log/fai/dirinstall/$HOSTNAME/software.log >> $LOGFILE && ERROR=2
-      grep 'ERROR: chroot' /var/log/fai/dirinstall/$HOSTNAME/software.log >> $LOGFILE && ERROR=3
+      # Unable to write mmap - msync (28 No space left on device)
+      # 'No candidate version found for' [/var/log/fai/current/software.log]
+      grep 'dpkg: error processing' $CHECKLOG/software.log >> $LOGFILE && ERROR=1
+      grep 'E: Method http has died unexpectedly!' $CHECKLOG/software.log >> $LOGFILE && ERROR=2
+      grep 'ERROR: chroot' $CHECKLOG/software.log >> $LOGFILE && ERROR=3
    fi
 
-   if [ -r "/var/log/fai/dirinstall/$HOSTNAME/shell.log" ] ; then
-      grep 'FAILED with exit code' /var/log/fai/dirinstall/$HOSTNAME/shell.log >> $LOGFILE && ERROR=2
+   if [ -r "$CHECKLOG/shell.log" ] ; then
+      grep 'FAILED with exit code' $CHECKLOG/shell.log >> $LOGFILE && ERROR=2
    fi
 
    if [ -n "$ERROR" ] ; then
       log "There was an error [${ERROR}] during execution of stage 'fai dirinstall' [$(date)]"
       eerror "There was an error during execution of stage 'fai dirinstall'"
-      echo "   Check out /var/log/fai/dirinstall/$HOSTNAME/ for details. [exit ${ERROR}]"
+      echo "   Check out $CHECKLOG for details. [exit ${ERROR}]"
       eend 1
       bailout 1
    else
@@ -295,33 +434,39 @@ fi
 [ -n "$BUILD_OUTPUT" ] || BUILD_OUTPUT="$OUTPUT/grml_cd"
 mkdir -p "$BUILD_OUTPUT" || bailout 6 "Problem with creating $BUILD_OUTPUT for stage ARCH"
 
-[ -n "$ARCH" ] || ARCH="$(dpkg --print-architecture)"
-
 # i386:
 if [ "$ARCH" = i386 ] || [ "$ARCH" = amd64 ] ; then
-   if [ -d "$BUILD_OUTPUT"/boot ] ; then
+   if [ -d "$BUILD_OUTPUT"/boot -a -z "$UPDATE" -a -z "$BUILD_ONLY" ] ; then
       log "$BUILD_OUTPUT/boot exists already, skipping stage 'boot'"
       ewarn "$BUILD_OUTPUT/boot exists already, skipping stage 'boot'" ; eend 0
    else
       # booting stuff:
-      mkdir -p "$BUILD_OUTPUT"/boot/isolinux
-      cp /boot/memtest86+.bin "$BUILD_OUTPUT"/boot/isolinux/memtest
+      [ -d "$BUILD_OUTPUT"/boot/addons   ] || mkdir -p "$BUILD_OUTPUT"/boot/addons
+      [ -d "$BUILD_OUTPUT"/boot/isolinux ] || mkdir -p "$BUILD_OUTPUT"/boot/isolinux
+      [ -d "$BUILD_OUTPUT"/boot/"${GRML_NAME}" ] || mkdir -p "$BUILD_OUTPUT"/boot/"${GRML_NAME}"
+
+      cp /boot/memtest86+.bin "$BUILD_OUTPUT"/boot/addons/memtest
 
       # if we don't have an initrd we a) can't boot and b) there was an error
       # during build, so check for the file:
-      if [ -f "$CHROOT_OUTPUT"/boot/initrd* ] ; then
-         cp "$CHROOT_OUTPUT"/boot/initrd*  "$BUILD_OUTPUT"/boot/isolinux/initrd.gz
+      INITRD="$(ls $CHROOT_OUTPUT/boot/initrd* 2>/dev/null| grep -v '.bak$' | sort -r | head -1)"
+      if [ -n "$INITRD" ] ; then
+         cp $INITRD "$BUILD_OUTPUT"/boot/"${GRML_NAME}"/initrd.gz
+         find $CHROOT_OUTPUT/boot/ -name initrd\*.bak -exec rm {} \;
       else
          log "No initrd found inside $CHROOT_OUTPUT/boot/ - Exiting"
          eerror "No initrd found inside $CHROOT_OUTPUT/boot/ - Exiting" ; eend 1
          bailout 10
       fi
 
-      cp "$CHROOT_OUTPUT"/boot/vmlinuz*                    "$BUILD_OUTPUT"/boot/isolinux/linux26
-      cp /usr/lib/syslinux/chain.c32                       "$BUILD_OUTPUT"/boot/isolinux/
-      cp /usr/lib/syslinux/isolinux.bin                    "$BUILD_OUTPUT"/boot/isolinux/
-      cp /usr/lib/syslinux/memdisk                         "$BUILD_OUTPUT"/boot/isolinux/
-      cp /usr/lib/syslinux/menu.c32                        "$BUILD_OUTPUT"/boot/isolinux/
+      KERNEL_IMAGE="$(ls $CHROOT_OUTPUT/boot/vmlinuz* 2>/dev/null | sort -r | head -1)"
+      if [ -n "$KERNEL_IMAGE" ] ; then
+         cp "$KERNEL_IMAGE" "$BUILD_OUTPUT"/boot/"${GRML_NAME}"/linux26
+      else
+         log "No kernel found inside $CHROOT_OUTPUT/boot/ - Exiting"
+         eerror "No kernel found inside $CHROOT_OUTPUT/boot/ - Exiting" ; eend 1
+         bailout 11
+      fi
 
       [ -n "$TEMPLATE_DIRECTORY" ] || TEMPLATE_DIRECTORY='/usr/share/grml-live/templates'
       if ! [ -d "${TEMPLATE_DIRECTORY}"/boot ] ; then
@@ -329,20 +474,24 @@ if [ "$ARCH" = i386 ] || [ "$ARCH" = amd64 ] ; then
          eerror "${TEMPLATE_DIRECTORY}/boot does not exist. Exiting." ; eend 1
          bailout 8
       fi
-      cp ${TEMPLATE_DIRECTORY}/boot/isolinux/*               "$BUILD_OUTPUT"/boot/isolinux/
-      cp ${TEMPLATE_DIRECTORY}/boot/isolinux/*               "$BUILD_OUTPUT"/boot/isolinux/
-      cp -a ${TEMPLATE_DIRECTORY}/boot/grub                  "$BUILD_OUTPUT"/boot/
+
+      cp ${TEMPLATE_DIRECTORY}/boot/isolinux/*  "$BUILD_OUTPUT"/boot/isolinux/
+      cp ${TEMPLATE_DIRECTORY}/boot/addons/*    "$BUILD_OUTPUT"/boot/addons/
+
+      if ! [ -d "${BUILD_OUTPUT}/boot/grub" ] ; then
+         cp -a ${TEMPLATE_DIRECTORY}/boot/grub  "$BUILD_OUTPUT"/boot/
+      fi
 
       if ! [ -d "${TEMPLATE_DIRECTORY}"/GRML ] ; then
          log "${TEMPLATE_DIRECTORY}/GRML does not exist. Exiting."
          eerror "${TEMPLATE_DIRECTORY}/GRML does not exist. Exiting." ; eend 1
          bailout 9
       fi
+
       [ -d "$BUILD_OUTPUT"/GRML ] || mkdir "$BUILD_OUTPUT"/GRML
       cp -a ${TEMPLATE_DIRECTORY}/GRML/* "$BUILD_OUTPUT"/GRML/
 
       # adjust boot splash information:
-      ISO_DATE="$(date +%Y-%m-%d)"
       RELEASE_INFO="$GRML_NAME $VERSION - Release Codename $RELEASENAME"
       RELEASE_INFO="$(cut_string 68 "$RELEASE_INFO")"
       RELEASE_INFO="$(extend_string_end 68 "$RELEASE_INFO")"
@@ -353,6 +502,9 @@ if [ "$ARCH" = i386 ] || [ "$ARCH" = amd64 ] ; then
       sed -i "s/%RELEASE_INFO%/$RELEASE_INFO/" "$BUILD_OUTPUT"/boot/isolinux/boot.msg
       sed -i "s/%DATE%/$ISO_DATE/"             "$BUILD_OUTPUT"/boot/isolinux/boot.msg
 
+      sed -i "s/%GRML_NAME%/$GRML_NAME/"       "$BUILD_OUTPUT"/boot/isolinux/isolinux.cfg
+      sed -i "s/%GRML_NAME%/$GRML_NAME/"       "$BUILD_OUTPUT"/boot/isolinux/syslinux.cfg
+
       sed -i "s/%RELEASE_INFO%/$RELEASE_INFO/" "$BUILD_OUTPUT"/boot/isolinux/boot-beep.msg
       sed -i "s/%DATE%/$ISO_DATE/"             "$BUILD_OUTPUT"/boot/isolinux/boot-beep.msg
 
@@ -363,17 +515,21 @@ if [ "$ARCH" = i386 ] || [ "$ARCH" = amd64 ] ; then
       if [ -d "${TEMPLATE_DIRECTORY}/windows/autostart/" ] ; then
          cp ${TEMPLATE_DIRECTORY}/windows/autostart/* "$BUILD_OUTPUT"/
       fi
+
       # windows-binaries:
       if [ -n "$WINDOWS_BINARIES" ] ; then
          if [ -f "$BUILD_OUTPUT"/windows/putty.exe ] ; then
             log "$BUILD_OUTPUT/windows exists already, skipping stage 'WINDOWS_BINARIES'"
             ewarn "$BUILD_OUTPUT/windows exists already, skipping stage 'WINDOWS_BINARIES'" ; eend 0
          else
-            mkdir "$BUILD_OUTPUT"/windows
-            ( cd "$BUILD_OUTPUT"/windows
-              for file in pageant plink pscp psftp putty puttygen ; do
-                 wget -O ${file}.exe ${WINDOWS_BINARIES}/${file}.exe
-              done )
+            if ! [ -d "$BUILD_OUTPUT"/windows ] ; then
+               mkdir "$BUILD_OUTPUT"/windows
+               ( cd "$BUILD_OUTPUT"/windows
+                 for file in pageant plink pscp psftp putty puttygen ; do
+                    wget -O ${file}.exe ${WINDOWS_BINARIES}/${file}.exe
+                    md5sum ${file}.exe > ${file}.exe.md5
+                 done )
+            fi
          fi
       log "Finished execution of stage 'WINDOWS_BINARIES' [$(date)]"
       einfo "Finished execution of stage 'WINDOWS_BINARIES'" ; eend 0
@@ -388,12 +544,22 @@ else
    eerror 'Error: Unsupported ARCH, sorry. Want to support it? Contribute!' ; eend 1
 fi
 
-if [ -f "$BUILD_OUTPUT"/live/grml.squashfs ] ; then
+if [ -f "$BUILD_OUTPUT"/live/grml.squashfs -a -z "$UPDATE" -a -z "$BUILD_ONLY" ] ; then
    log "$BUILD_OUTPUT/live exists already, skipping stage 'squashfs'"
    ewarn "$BUILD_OUTPUT/live exists already, skipping stage 'squashfs'" ; eend 0
 else
-   mkdir "$BUILD_OUTPUT"/live
-   mksquashfs $CHROOT_OUTPUT/* $BUILD_OUTPUT/live/grml.squashfs -noappend
+   [ -d "$BUILD_OUTPUT"/live ] || mkdir "$BUILD_OUTPUT"/live
+   # make sure we don't leave (even an empty) base.tgz:
+   [ -f "$CHROOT_OUTPUT/base.tgz" ] && rm -f "$CHROOT_OUTPUT/base.tgz"
+
+   # execute squashfs:
+   if mksquashfs --help 2>&1 | grep -q -- -no-progress ; then
+      log "mksquashfs $CHROOT_OUTPUT/* $BUILD_OUTPUT/live/grml.squashfs -noappend -no-progress"
+      mksquashfs $CHROOT_OUTPUT/* $BUILD_OUTPUT/live/"${GRML_NAME}".squashfs -noappend -no-progress $SQUASHFS_OPTIONS $SQUASHFS_ZLIB
+   else
+      log "mksquashfs $CHROOT_OUTPUT/* $BUILD_OUTPUT/live/grml.squashfs -noappend"
+      mksquashfs $CHROOT_OUTPUT/* $BUILD_OUTPUT/live/"${GRML_NAME}".squashfs -noappend $SQUASHFS_OPTIONS $SQUASHFS_ZLIB
+   fi
    log "Finished execution of stage 'squashfs' [$(date)]"
    einfo "Finished execution of stage 'squashfs'" ; eend 0
 fi
@@ -413,18 +579,32 @@ elif [ "$BOOT_METHOD" = "grub" ] ; then
    BOOT_FILE="boot/grub/stage2_eltorito"
 fi
 
-if [ -f "${ISO_OUTPUT}/${ISO_NAME}" ] ; then
+if [ -f "${ISO_OUTPUT}/${ISO_NAME}" -a -z "$UPDATE" -a -z "$BUILD_ONLY" ] ; then
    log "$ISO_OUTPUT exists already, skipping stage 'iso build'"
    ewarn "$ISO_OUTPUT exists already, skipping stage 'iso build'" ; eend 0
 else
    mkdir -p "$ISO_OUTPUT" || bailout 6 "Problem with creating $ISO_OUTPUT for stage 'iso build'"
+
    CURRENT_DIR=$(pwd)
-   cd "$BUILD_OUTPUT" &&
-   mkisofs -V "grml $VERSION" -publisher 'grml-live | grml.org' \
-           -l -r -J -no-emul-boot -boot-load-size 4 -boot-info-table    \
-           -b $BOOT_FILE \
-           -o "${ISO_OUTPUT}/${ISO_NAME}" . ; RC=$?
-   cd $CURRENT_DIR
+   if cd "$BUILD_OUTPUT" ; then
+      log "mkisofs -V grml '$VERSION' -publisher 'grml-live | grml.org' -l -r -J -no-emul-boot -boot-load-size 4 -boot-info-table -b $BOOT_FILE -o ${ISO_OUTPUT}/${ISO_NAME} ."
+      mkisofs -V "grml $VERSION" -publisher 'grml-live | grml.org' \
+              -l -r -J -no-emul-boot -boot-load-size 4 -boot-info-table    \
+              -b $BOOT_FILE \
+              -o "${ISO_OUTPUT}/${ISO_NAME}" . ; RC=$?
+
+      # generate md5sum of ISO if we are using class 'RELEASE':
+      case $CLASSES in *RELEASE*)
+         [ "$RC" = 0 ] && \
+         ( cd $ISO_OUTPUT && \
+         md5sum ${ISO_NAME} > ${ISO_NAME}.md5 && \
+         touch -r ${ISO_NAME} ${ISO_NAME}.md5 )
+         ;;
+      esac
+
+      cd $CURRENT_DIR
+   fi
+
    if [ "$RC" = 0 ] ; then
       log "Finished execution of stage 'iso build' [$(date)]"
       einfo "Finished execution of stage 'iso build'" ; eend 0
@@ -437,10 +617,9 @@ fi
 # }}}
 
 # finalize {{{
-[ -n "$start_seconds" ] && SECONDS="$[$(cut -d . -f 1 /proc/uptime)-$start_seconds]"
+[ -n "$start_seconds" ] && SECONDS="$[$(cut -d . -f 1 /proc/uptime)-$start_seconds]" || SECONDS="unknown"
 einfo "Sucessfully finished execution of $PN [running ${SECONDS} seconds]" ; eend 0
 log "Sucessfully finished execution of $PN [running ${SECONDS} seconds]"
-log "------------------------------------------------------------------------------"
 bailout 0
 # }}}